theory Container_Setup
imports 
  "$AFP/Abstract-Rewriting/SN_Order_Carrier"
  "$AFP/Containers/Containers" 
  "$AFP/Real_Impl/Real_Impl"
  "../Framework/Linear_Orders"
  "../Orderings/Linear_Polynomial"
  "../Rewriting/Forbidden_Patterns"
  "../Tree_Automata/Tree_Automata"
begin

(* term, etc *)
derive (eq) ceq 
  pos lab "term" mctxt ctxt gctxt location l_poly ta_rule rat real arctic arctic_delta
derive compare (* for these types there is already an order defined, so no compare_order poss. *) 
  pos mctxt arctic arctic_delta
derive (linorder) compare_order 
  rat real
derive compare_order
  ctxt location l_poly ta_rule
derive (compare) ccompare 
  pos lab "term" mctxt ctxt gctxt location l_poly ta_rule rat real arctic arctic_delta
derive (rbt) set_impl 
  pos lab "term" mctxt ctxt gctxt location l_poly ta_rule rat real arctic arctic_delta
derive (no) cenum 
  pos lab "term" mctxt ctxt gctxt location l_poly ta_rule rat real arctic arctic_delta
derive (rbt) mapping_impl
  lab

instantiation pos :: finite_UNIV
begin
definition "finite_UNIV = Phantom(pos) False"
instance
  by (intro_classes, unfold finite_UNIV_pos_def, simp)
end

instantiation pos :: cproper_interval
begin
definition "cproper_interval = (\<lambda> ( _ :: pos option) _ . False)"
instance by (intro_classes, auto)
end

instantiation lab :: (type,type)card_UNIV
begin
definition "card_UNIV = Phantom(('a,'b)lab) 0"
definition "finite_UNIV = Phantom(('a,'b)lab) False"
instance
  by (intro_classes, auto simp: finite_UNIV_lab_def card_UNIV_lab_def infinite_lab)
end


instantiation lab :: (compare,compare)cproper_interval
begin
definition "cproper_interval = (\<lambda> ( _ :: ('a,'b)lab option) _ . False)"
instance by (intro_classes, auto simp: infinite_lab)
end


instantiation ta_rule :: (type,type)finite_UNIV
begin
definition "finite_UNIV = Phantom(('a,'b)ta_rule) False"
instance
  by (intro_classes, unfold finite_UNIV_ta_rule_def, simp)
end

instantiation ta_rule :: (compare,compare)cproper_interval
begin
definition "cproper_interval = (\<lambda> ( _ :: ('a,'b)ta_rule option) _ . False)"
instance by (intro_classes, auto)
end

text \<open>code equation to handle @{term Union}\<close>
lemma un_foldr[code_unfold]: "\<Union> (set xs) = foldr (op \<union>) xs {}"
  by (induct xs, auto)

end
